org.apache.lucene.sandbox.queries

## Class FuzzyLikeThisQuery

- java.lang.Object
- - org.apache.lucene.search.Query
  - - org.apache.lucene.sandbox.queries.FuzzyLikeThisQuery

    public class FuzzyLikeThisQuery
    extends Query

Fuzzifies ALL terms provided as strings and then picks the best n differentiating terms. In effect this mixes the behaviour of FuzzyQuery and MoreLikeThis but with special consideration of fuzzy scoring factors. This generally produces good results for queries where users may provide details in a number of fields and have no knowledge of boolean query syntax and also want a degree of fuzzy matching and a fast query. For each source term the fuzzy variants are held in a BooleanQuery with no coord factor (because we are not looking for matches on multiple variants in any one doc). Additionally, a specialized TermQuery is used for variants and does not use that variant term's IDF because this would favour rarer terms eg misspellings. Instead, all variants use the same IDF ranking (the one for the source query term) and this is factored into the variant's boost. If the source query term does not exist in the index the average IDF of the variants is used.

### Constructor Summary

Constructors
Constructor and Description
`FuzzyLikeThisQuery(int maxNumTerms, Analyzer analyzer)`

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `addTerms(String queryString, String fieldName, float minSimilarity, int prefixLength)` Adds user input for "fuzzification"
`boolean` `equals(Object other)`
`int` `hashCode()`
`boolean` `isIgnoreTF()`
`Query` `rewrite(IndexReader reader)`
`void` `setIgnoreTF(boolean ignoreTF)`
`String` `toString(String field)`
`void` `visit(QueryVisitor visitor)`

### Methods inherited from class org.apache.lucene.search.Query

`classHash, createWeight, sameClassAs, toString`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### FuzzyLikeThisQuery

    public FuzzyLikeThisQuery(int maxNumTerms,
                              Analyzer analyzer)

Parameters:
  `maxNumTerms` - The total number of terms clauses that will appear once rewritten as a BooleanQuery

### Method Detail

#### hashCode

    public int hashCode()

Specified by:
  `hashCode` in class `Query`

#### equals

    public boolean equals(Object other)

Specified by:
  `equals` in class `Query`

#### addTerms

    public void addTerms(String queryString,
                         String fieldName,
                         float minSimilarity,
                         int prefixLength)

Adds user input for "fuzzification"

Parameters:
  `queryString` - The string which will be parsed by the analyzer and for which fuzzy variants will be parsed
  `minSimilarity` - The minimum similarity of the term variants; must be 0, 1 or 2 (see FuzzyTermsEnum)
  `prefixLength` - Length of required common prefix on variant terms (see FuzzyTermsEnum)

#### visit

    public void visit(QueryVisitor visitor)

Overrides:
  `visit` in class `Query`

#### rewrite

    public Query rewrite(IndexReader reader)
                  throws IOException

Overrides:
  `rewrite` in class `Query`
Throws:
  `IOException`

#### toString

    public String toString(String field)

Specified by:
  `toString` in class `Query`

#### isIgnoreTF

    public boolean isIgnoreTF()

#### setIgnoreTF

    public void setIgnoreTF(boolean ignoreTF)